#-*-coding:utf-8-*-

"""
Analyse un midifile et enregistre
les données et les informations
recueillies sous forme lisible.
Consulter le manuel pour les applications.
TOUT N'EST PAS TESTE !
"""

import array as AR
import conversions
import os
import sys

__date__ = "2004.08.22, 04.11.11, 09.02.12 "
__author__ = "Copyright (c) 2005-2009 René Bastian (Wissembourg, FRANCE)"


def _tochar(X):
    """
    traduit les octets de 'X' en chaîne
    """
    s = ""
    for x in X:
        s = s + chr(x)
    return s + "\n"
        
headerL = 4 + 4 + 3*2
debogue = 1

def _usage():
    """midi2quad <midifile> <texte>
    (c) René Bastian 2004
    traduit un midifile
       en un texte <midifile>.data (cmn, velocity, temps, duree)
       en un texte <midifile>.info (texte)
       en un texte <midifile>.quad (freq, duree, ampli, point_temporel)
    """
    print __doc__

def _erreur(s):
    "affiche ERREUR et s'en va"
    print "ERREUR : ", s
    sys.exit()

def affichage(listeE):
    "affiche listeE"
    formatD = "%2i %3i %3i %-6s %3i %12i %12i %12i"
    for e in listeE:
        if e[1] == 144:
            s = conversions.midi2cmn(e[2])
        elif e[1] == 128:
            s = "-" + conversions.midi2cmn(e[2])
        else:
            s = ""
        print formatD % (e[0], e[1], e[2], s, e[3], e[4], e[5], e[6])


CmdMidi = {
    0x80 : "Off", 0x90 : "On", 0xA0: "PAt", 0xB0:"Ctrl",
    0xC0 : "Prg", 0xD0 : "CAt",0xE0: "PBn"}

def enregistrementBrut(nom_brut, listeE):
    """
    enreistre une forme brute de 'E' dans le fichier 'nom_brut'
    """
    formatD = "%2i %-5s %7i %-6s %3i %12i %12i %12i\n"
    f = open(nom_brut, "w")
    for e in listeE:        
        try:
            smidi = CmdMidi[e[1]]
            if e[1] == 144:
                ston = conversions.midi2cmn(e[2])
            elif e[1] == 128:
                ston = "-" + conversions.midi2cmn(e[2])
                e[6] = 0
            else:
                ston = ""
            s = formatD % (e[0], smidi, e[2], ston, e[3], e[4], e[5], e[6])
            f.write(s)
        except TypeError:
            print e
    f.close()

def enregistrementReduit(E, nom):
    """
    enreistre une forme réduite de 'E' dans le fichier 'nom'
    """
    
    formatD = "%-6s %3i %12i %12i\n"
    f = open(nom, "w")
    for e in E:        
        try:
            
            if e[1] == 144:
                ston = conversions.midi2cmn(e[2])
                s = formatD % (ston, e[3], e[5], e[6])
                f.write(s)
        except TypeError:
            print e
    f.close()

def midi2quadruple(listeE, nom, cDuree, cAmpli, cPt):
    "affiche un quadruple MIDI"
    
    formatT = "%12.6f %12.7f %12.7f %12.7f\n" 
    f = open(nom, "w")
    for e in listeE:        
        try:
            
            if e[1] == 144:
                freq = conversions.midi2freq(e[2])
                ampli = float(e[3])*cAmpli/128
                duree = float(e[6])*cDuree
                pt = float(e[5])*cPt
                s = formatT % (freq, duree, ampli, pt)
                f.write(s)
        except TypeError:
            print e
    f.close()
    
def tracks(h):
    "retourne l'élément [1] du track 'h'"
    return h[1]

def format(h):
    "retourne l'élément [1] du track 'h'"
    return h[1]

def entier16(h):
    "calcule un entier sur 16 bits"
    return h[1] + 256*h[0]

def entier24(h):
    "calcule un entier sur 24 bits"
    return h[2] + 256*h[1] + 256*256*h[0]

def entier32(h):
    "calcule un entier sur 32 bits"
    return h[3] + 256*h[2] + 256*256*h[1] + 256*256*256*h[0]

C128_3 = 128*128*128
C128_2 = 128*128

def deltatime(a):
    """
    calcul en clair du 'deltatime'
    """
    if len(a) == 1:
        return a[0]
    elif len(a) == 2:        
        return (a[0]&0x7F)*128 + a[1]
    elif len(a) == 3:
        return (a[0]&0x7F)*C128_2 + (a[1]&0x7F)*128 + a[2]
    elif len(a) == 4:
        return (a[0]&0x7F)*C128_3 + (a[1]&0x7F)*C128_2 + \
            (a[2]&0x7F)*128 + a[3]    
    else:
        return None


def temps(M, ix, time):
    """
    presque comme 'capterdelta'
    mais calcule le temps chronologiquement ;-)
    """
    delta = []
    while M[ix] > 0x80:
        delta.append(M[ix])
        ix = ix + 1
    delta.append(M[ix])
    ix = ix + 1
    ecart = deltatime(delta)
    time = time + ecart
    return ix, ecart, time

def capterdelta(M, i):
    """
    calcule le 'deltatime'
    """
    delta = []
    while M[i] > 0x80:
        delta.append(M[i])
        i = i + 1
    delta.append(M[i])
    i = i + 1
    valeur = deltatime(delta)
    return i, valeur

def analyse(E):
    """
    Calcule les durées des événements.
    Chaque élément de la liste E a la structure :
    [canal, status, val0, val1, ecart, temps, duree]
    @param E : liste des événements    
    """
    i = 0
    while i < len(E):
        if E[i][1] == 0x80:
            j = i-1
            while j > 0:
                if (E[j][1] == 0x90) and \
                       (E[j][2] == E[i][2]) and \
                       (E[j][0] == E[i][0]):
                
                    E[j][6] = E[i][5]-E[j][5]
                    
                    E[i][6] = E[i][5]-E[j][5] 
                    break
                else:
                    j = j-1
        i = i + 1
    return E

def decodage(nom_source):
    """
    décodage d'un fichier
    """
    Info = []
    f = open(nom_source,"rb")
    dimension = os.fstat(f.fileno()).st_size
    
    M = AR.array('B')
    M.fromfile(f, dimension)
    E = []
    
    nx = format(M[8:10])
    infos = "%-12s %7i\n" % ("Format", nx)
    Info.append(infos)
    
    nx = tracks(M[10:12])
    infos = "%-12s %7i\n" % ("N tracks", nx)
    Info.append(infos)
    
    nx = entier16(M[12:14])    
    infos = "%-12s %7i\n" % ("N ticks", nx)
    Info.append(infos)
    
    nx = entier32(M[18:22])    
    nx = tracks(M[10:12])
    infos = "%-12s %7i\n" % ("N bytes", nx)
    status = None
    canal = None
    ix = 22
    time = 0
    while ix < len(M):
        
        ix, ecart, time = temps(M, ix, time)
        if 0x80 <= M[ix] < 0xF0 :
            status = (M[ix] & 0xf0) 
            canal = (M[ix] & 0xf) 
        
        if M[ix] == 0xff:
            if M[ix+1] == 0x00: 
                
                
                nx = entier16(M[ix+3:ix+5])
                infos = "%-12s %7i\n" % ("N ticks", nx)
                Info.append(infos)
                
            elif M[ix+1] == 0x01: 
                
                print "Text event"
                ix = ix + 2
                ix, d = capterdelta(M, ix)
                textevent = M[ix:ix+d]
                ix = ix + d
                
                Info.append(textevent)
            elif M[ix+1] == 0x02: 
                
                print "Copyright"
                ix = ix + 2
                ix, d = capterdelta(M, ix)
                copyrightnotice = M[ix:ix+d]                
                ix = ix + d
                Info.append(copyrightnotice)
            elif M[ix+1] == 0x03: 
                
                print "Sequ or track name"
                ix = ix + 2
                ix, d = capterdelta(M, ix)
                sequencerortrackname = M[ix:ix+d]
                ix = ix + d
                Info.append(sequencerortrackname)
            elif M[ix+1] == 0x04: 
                
                print "Instrument"
                ix = ix + 2
                ix, d = capterdelta(M, ix)
                instrumentname = M[ix:ix+d]
                
                ix = ix + d
                Info.append(instrumentname)
            elif M[ix+1] == 0x05: 
                
                print "Lyric"
                ix = ix + 2
                ix, d = capterdelta(M, ix)
                lyric = M[ix:ix+d]
                ix = ix + d
                Info.append(lyric)
            elif M[ix+1] == 0x06: 
                
                print "Marker", time
                ix = ix + 2
                ix, d = capterdelta(M, ix)
                marker = M[ix:ix+d]
                ix = ix + d
                Info.append(marker)
            elif M[ix+1] == 0x07: 
                
                print "Cue point", time
                ix = ix + 2
                ix, d = capterdelta(M, ix)
                cuepoint = M[ix:ix+d]
                ix = ix + d
                Info.append(cuepoint)
            elif   M[ix+1] == 0x20: 
                
                print "Prefix"
                ix = ix + 3
                nx = M[ix]
                ix = ix + 1
                
                infos = "%-12s %7i %8i\n" % ("Prefix", nx, time)
                Info.append(infos)
                
            elif   M[ix+1] == 0x2f: 
                print "C'est tout !"
                break
            elif M[ix+1] == 0x51: 
                nx = entier24(M[ix+3:ix+6])
                ix = ix + 6
                infos = "%-12s %7i %8i\n" % ("Tempo", nx, time)
                Info.append(infos)
                
            elif M[ix+1] == 0x54: 
                ix = ix + 3
                
                ix = ix + 1
                
                ix = ix + 1
                
                ix = ix + 1
                
                ix = ix + 1
                
                ix = ix + 1
            elif M[ix+1] == 0x59: 
                ix = ix + 3
                
                ix = ix + 1
                
                ix = ix + 1                
            elif M[ix+1] == 0x58: 
                num = M[ix+3]
                den = M[ix+4]
                
                
                ix = ix + 7
                print "Rythme %i/%i" % (num, den)
            
            elif M[ix+1] == 0x7f: 
                
                ix = ix + 2
                ix, d = capterdelta(M, ix)
                
                ix = ix + d
        
        elif 0xa0 <= M[ix] <= 0xaf: 
            polykeypressure = M[ix+1:ix+3]
            if debogue : 
                print "PolyK", canal, polykeypressure
            E.append([canal, status, polykeypressure, 0, ecart, time, 0])
            ix = ix + 3        
        elif 0xb0 <= M[ix] <= 0xbf: 
            controlchange = entier16(M[ix+1:ix+3])
            if debogue : 
                print "CtrChg", canal, controlchange
            E.append([canal, status, controlchange, 0, ecart, time, 0])
            ix = ix + 3
        elif 0xc0 <= M[ix] <= 0xcf: 
            programchange = M[ix+1]
            if debogue : 
                print "ProgChg", canal, programchange
            E.append([canal, status, programchange, 0, ecart, time, 0])
            ix = ix + 2
        elif 0xd0 <= M[ix] <= 0xdf: 
            aftertouch = M[ix+1:ix+3]
            if debogue : 
                print "AfterT", canal, aftertouch
            E.append([canal, status, aftertouch, 0, ecart, time, 0])
            ix = ix + 2
        elif 0xe0 <= M[ix] <= 0xef: 
            pitchbend = M[ix+1:ix+3]
            E.append([canal, status, pitchbend, 0, ecart, time, 0])
            ix = ix + 3
        elif 0x80 <= M[ix] <= 0x8f: 
            noteoff = M[ix+1]
            velocity = M[ix+2]
            if debogue : 
                print "Note Off %i %i %i" % (canal, noteoff, velocity)
            E.append([canal, status, noteoff, velocity, ecart, time, 0])
            ix = ix + 3            
            continue
        elif 0x90 <= M[ix] <= 0x9f: 
            noteon = M[ix+1]
            velocity = M[ix+2]
            if debogue : 
                print "Note On %i %i %i" % (canal, noteon, velocity)
            E.append([canal, status, noteon, velocity, ecart, time, 0])
            ix = ix + 3
            continue
        elif M[ix]<0x80:
            
            if status == 0x90:
                noteon = M[ix]
                ix = ix + 1
                velocity = M[ix]
                ix = ix + 1
                if debogue :
                    print "Note On %i %i %i" % (canal, noteon, velocity)
                E.append([canal, status, noteon, velocity, ecart, time, 0])
            elif status == 0x80:
                noteoff = M[ix]
                ix = ix + 1
                velocity = M[ix]
                ix = ix + 1
                if debogue :
                    print "Note Off %i %i %i" % (canal, noteoff, velocity)
                E.append([canal, status, noteoff, velocity, ecart, time, 0])
    f.close()
    return E, Info
def enregistrementInfo(nom_info, Info):
    """
    fonction naïve pour enregistrer les infos.
    """
    X = []    
    for s in Info:
        if type(s) != type(""):
            X.append(_tochar(s))
        else :
            X.append(s)
    f = open(nom_info, "w")
    print X
    f.writelines(X)
    f.close()

if __name__ == "__main__":
    _usage()
    
    if len(sys.argv) < 3:
        _erreur("Il faut deux arguments")
        sys.exit()
    xnom_source = sys.argv[1]
    xnom_brut   = sys.argv[2] + ".brut"
    nom_reduit = sys.argv[2] + ".data"
    xnom_info   = sys.argv[2] + ".info"
    nom_quad   = sys.argv[2] + ".quad"
    xE, xInfo = decodage(xnom_source)
    enregistrementBrut(xnom_brut, xE)
    enregistrementInfo(xnom_info, xInfo)
    xE = analyse(xE)
    if debogue :
        print " = "*50
        affichage(xE)
    xDuree = 0.005
    xAmpli = 1.
    xPt = 0.005
    midi2quadruple(xE, nom_quad, xDuree, xAmpli, xPt)    
    enregistrementReduit(xE, nom_reduit)
    


