#-*-coding:utf-8-*-

"""formes en dent de scie.
Ces formes raides sont obsolètes dans le projet 'pythoneon' car il
suffit de dessiner une table avec des profils et de parcourir cette
table par un balayage.
"""

import numpy as NY
from samplerate import sr
from conversions08 import prony2freq
from origine import Origine
__author__ = "Copyright (c) 2005-09 René Bastian (Wissembourg, FRANCE)"
__date__ = "2007.10.05, 09.02.02"


class Saegezahn(Origine):
    """
    classe pour produire des 'dents de scie'
    """
    def __init__(self):
        """
        La théorie :
        On 'x' passe de 0. à 2. en 'n' pas en additionnant 'dx=2./n'
        donc 'x += dx'.
        'periode = n/sr' ; 'freq = sr/n' ; 'n=sr/freq' ; 'dx=2./n'
        puis on essaie 'add.accumulate' et le reste.
        """        
        Origine.__init__(self)

    def fixe(self, duree, hauteur, prony=False):
        """
        un saegezahn de fréquence constante
        """
        ph = [[_p.recta, duree, freq, freq]]
        return self(duree, phauteur, prony)
        
    def evt(self, mfreqs, prony=False):
        """
        'mfreqs' : un vecteur de hauteurs
        """
        if prony:
            mfreqs = prony2freq(mfreqs)
        dx = 2. * mfreqs / sr
        w = NY.add.accumulate(dx)
        w = (w % 2.0) - 1.0
        return w
    
    def __call__(self, duree, phauteur, prony=True):
        """
        'duree' : durée en sec
        'phauteur' : évolution de la hauteur, liste-profil        
        'prony=True' : prony ou Hz
        """
        mf = _p.ProfilBase(phauteur).temps(duree)
        if prony:
            mf = prony2freq(mf)
        dx = 2. * mf / sr
        w = NY.add.accumulate(dx)
        w = (w % 2.0) - 1.0
        return w
    


