#-*-coding:utf-8-*-

"""
suitesindices.py fournit la classe SuiteIndex
qui devrait permettre de manipuler des listes d'indices qui
se réfèrent à des gammes, mélodies, listes d'objets.
"""
import numpy as NY

__author__ = "Copyright (c) 2005-07 René Bastian (Wissembourg, FRANCE)"
__date__ = "2007.04.16"


class SuiteIndex:
    """classe pour manipuler des suites d'index:
    - transposition
    - symétrie
    - rétroversion
    - inversion
    """
    def __init__(self, suite):
        """
        'suite' : liste de nombres entiers == liste d'index
        """
        self.suite = NY.array(suite)
        
    def transpo(self, n):
        "ajoute 'n' à chaque valeur de la suite"
        return self.suite + n
    
    def reverse(self):
        "retourne la forme rétrograde"
        return self.suite[::-1]
    
    def symetrique(self, q):
        """
        symétrique par rapport à 'q'
        """
        return 2*q - self.suite

    def inverse(self, q):
        """
        inverse à partir de 'q'
        """
        return q - self.suite
        


